diff --git a/src/common/resources/lang/en_US/biomes.lang b/src/common/resources/lang/en_US/biomes.lang
index c23b3ab8d..41dd17986 100644
--- a/src/common/resources/lang/en_US/biomes.lang
+++ b/src/common/resources/lang/en_US/biomes.lang
@@ -18,4 +18,5 @@ biome.birch_forest=Birch Forest
 biome.retro=Retro
 biome.hell=Hell
 biome.swampland.muddy=Muddy Swamp
-biome.outback.grassy=Grassy Outback
\ No newline at end of file
+biome.outback.grassy=Grassy Outback
+biome.caatinga=Caatinga
\ No newline at end of file
diff --git a/src/common/resources/lang/en_US/gui.lang b/src/common/resources/lang/en_US/gui.lang
index 7f5c35b27..97fd15cfb 100644
--- a/src/common/resources/lang/en_US/gui.lang
+++ b/src/common/resources/lang/en_US/gui.lang
@@ -65,6 +65,16 @@ gui.create_world.button.world_type=World Type: %s
 gui.create_world.label.new_world=New World
 gui.create_world.label.select_world_type=Select World Type
 
+gui.create_world.label.title=Create New World
+gui.create_world.button.cancel=Cancel
+gui.create_world.button.create_world=Create World
+
+gui.create_world.pages.general.title=General
+gui.create_world.pages.general.label.world_name=World Name
+gui.create_world.pages.general.label.world_seed=World Seed
+gui.create_world.pages.world_settings.title=World Settings
+gui.create_world.pages.game_rules.title=Game Rules
+
 gui.dispenser.label.dispenser=Dispenser
 gui.dispenser.label.inventory=Inventory
 
diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index 18a77b08b..858e62a38 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -2180,7 +2180,7 @@ public class Minecraft
                 bedSpawnCoordinates = EntityPlayer.getValidBedSpawnCoordinates(theWorld, spawnCoordinates);
                 if(bedSpawnCoordinates == null)
                 {
-                    thePlayer.addChatMessage("bed.notValid");
+                    thePlayer.sendTranslatedChatMessage("bed.notValid");
                 }
             }
         }
diff --git a/src/main/java/net/minecraft/client/entity/player/EntityOtherPlayerMP.java b/src/main/java/net/minecraft/client/entity/player/EntityOtherPlayerMP.java
index 85975ee39..6eb59bb5e 100644
--- a/src/main/java/net/minecraft/client/entity/player/EntityOtherPlayerMP.java
+++ b/src/main/java/net/minecraft/client/entity/player/EntityOtherPlayerMP.java
@@ -8,16 +8,12 @@ package net.minecraft.client.entity.player;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.GetSkinUrlThread;
 
-import java.util.ArrayList;
-import java.util.List;
-
 public class EntityOtherPlayerMP extends EntityPlayer
 {
 
@@ -49,14 +45,14 @@ public class EntityOtherPlayerMP extends EntityPlayer
 
     @Override
 	public void lerpTo(double x, double y, double z, float yRot,
-                       float xRot, int i)
+                       float xRot, int ticks)
     {
-        field_784_bh = x;
-        field_783_bi = y;
-        field_782_bj = z;
-        field_780_bk = yRot;
-        field_786_bl = xRot;
-        field_785_bg = i;
+        lerpX = x;
+        lerpY = y;
+        lerpZ = z;
+        lerpYRot = yRot;
+        lerpXRot = xRot;
+        lerpTicks = ticks;
     }
 
     @Override
@@ -65,9 +61,10 @@ public class EntityOtherPlayerMP extends EntityPlayer
         field_22062_y = 0.0F;
         super.tick();
         prevLimbYaw = limbYaw;
-        double d = x - xo;
-        double d1 = z - zo;
-        float f = MathHelper.sqrt_double(d * d + d1 * d1) * 4F;
+        xd = x - xo;
+        yd = y - yo;
+        zd = z - zo;
+        float f = MathHelper.sqrt_double(xd * xd + zd * zd) * 4F;
         if(f > 1.0F)
         {
             f = 1.0F;
@@ -91,36 +88,34 @@ public class EntityOtherPlayerMP extends EntityPlayer
 	public void onLivingUpdate()
     {
         super.updatePlayerActionState();
-        if(field_785_bg > 0)
+        if(lerpTicks > 0)
         {
-            double d = x + (field_784_bh - x) / (double)field_785_bg;
-            double d1 = y + (field_783_bi - y) / (double)field_785_bg;
-            double d2 = z + (field_782_bj - z) / (double)field_785_bg;
-            double d3;
-            for(d3 = field_780_bk - (double) yRot; d3 < -180D; d3 += 360D) { }
-            for(; d3 >= 180D; d3 -= 360D) { }
-            yRot += d3 / (double)field_785_bg;
-            xRot += (field_786_bl - (double) xRot) / (double)field_785_bg;
-            field_785_bg--;
+            double d = x + (lerpX - x) / (double) lerpTicks;
+            double d1 = y + (lerpY - y) / (double) lerpTicks;
+            double d2 = z + (lerpZ - z) / (double) lerpTicks;
+            double d3 = MathHelper.normalizeRotation(lerpYRot - (double) yRot);
+            yRot += d3 / (double) lerpTicks;
+            xRot += (lerpXRot - (double) xRot) / (double) lerpTicks;
+            lerpTicks--;
             setPos(d, d1, d2);
             setRot(yRot, xRot);
         }
         field_775_e = field_774_f;
-        float f = MathHelper.sqrt_double(xd * xd + zd * zd);
-        float f1 = (float) java.lang.Math.atan(-yd * 0.20000000298023224D) * 15F;
-        if(f > 0.1F)
+        float horizontalSpeed = MathHelper.sqrt_double(xd * xd + zd * zd);
+        float f1 = (float) Math.atan(-yd * 0.2D) * 15F;
+        if(horizontalSpeed > 0.1F)
         {
-            f = 0.1F;
+            horizontalSpeed = 0.1F;
         }
         if(!onGround || getHealth() <= 0)
         {
-            f = 0.0F;
+            horizontalSpeed = 0.0F;
         }
         if(onGround || getHealth() <= 0)
         {
             f1 = 0.0F;
         }
-        field_774_f += (f - field_774_f) * 0.4F;
+        field_774_f += (horizontalSpeed - field_774_f) * 0.4F;
         cameraPitch += (f1 - cameraPitch) * 0.8F;
     }
 
@@ -145,12 +140,21 @@ public class EntityOtherPlayerMP extends EntityPlayer
 	public void func_6420_o()
     {
     }
+	@Override
+	public void sendMessage(String message) {
+		
+	}
+
+	@Override
+	public void sendStatusMessage(String message) {
+		
+	}
 
-    private int field_785_bg;
-    private double field_784_bh;
-    private double field_783_bi;
-    private double field_782_bj;
-    private double field_780_bk;
-    private double field_786_bl;
+    private int lerpTicks;
+    private double lerpX;
+    private double lerpY;
+    private double lerpZ;
+    private double lerpYRot;
+    private double lerpXRot;
     float field_20924_a;
 }
diff --git a/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java b/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java
index 0fc8b0427..45824e61c 100644
--- a/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java
+++ b/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java
@@ -427,13 +427,7 @@ public class EntityPlayerSP extends EntityPlayer
     public void func_6420_o()
     {
     }
-
-    @Override
-    public void addChatMessage(String s)
-    {
-        mc.ingameGUI.addChatMessageTranslate(s);
-    }
-
+    
     @Override
     public void addStat(Stat statbase, int i)
     {
@@ -530,6 +524,16 @@ public class EntityPlayerSP extends EntityPlayer
     public void syncPlacementMode() {
         this.placementModeOverride = mc.gameSettings.placementMode.value;
     }
+    
+	@Override
+	public void sendMessage(String message) {
+		mc.ingameGUI.addChatMessage(message);
+	}
+
+	@Override
+	public void sendStatusMessage(String message) {
+		mc.ingameGUI.guiHeldItemTooltip.setString(message);
+	}
 
     public PlayerInput input;
     protected Minecraft mc;
diff --git a/src/main/java/net/minecraft/client/gui/GuiIngame.java b/src/main/java/net/minecraft/client/gui/GuiIngame.java
index ea0dc51f9..5b7adb0b3 100644
--- a/src/main/java/net/minecraft/client/gui/GuiIngame.java
+++ b/src/main/java/net/minecraft/client/gui/GuiIngame.java
@@ -268,7 +268,7 @@ public class GuiIngame extends Gui
 
                 if (rotaryCalendar)
                 {
-                    Season season = mc.theWorld.seasonManager.getCurrentSeason();
+                    Season season = mc.theWorld.getSeasonManager().getCurrentSeason();
                     String seasonString = season != null ? season.getTranslatedName() : "None";
                     Weather weather = mc.theWorld.getCurrentWeather();
                     String weatherString = weather != null ? weather.getTranslatedName() : "None";
@@ -418,7 +418,7 @@ public class GuiIngame extends Gui
                 {
                     if (mc.gameSettings.overlayShowSeason.value)
                     {
-                        Season season = mc.theWorld.seasonManager.getCurrentSeason();
+                        Season season = mc.theWorld.getSeasonManager().getCurrentSeason();
                         if (season != null)
                         {
                             this.drawString(fontrenderer, season.getTranslatedName(), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0x80ffff : 0xffffff);
@@ -785,7 +785,7 @@ public class GuiIngame extends Gui
             if (alpha > 0)
             {
                 byte xPad = 2;
-                int y = -(i - chatScroll) * 9;
+                int y = -(i - chatScroll) * 9 - 12;
                 String s1 = chatMessageList.get(i).message;
                 drawRect(xPad, y - 1 - sp, xPad + 320, y + 8 - sp, alpha / 2 << 24);
                 GL11.glEnable(GL_BLEND);
diff --git a/src/main/java/net/minecraft/client/gui/GuiInventory.java b/src/main/java/net/minecraft/client/gui/GuiInventory.java
index a12370bca..0588d754a 100644
--- a/src/main/java/net/minecraft/client/gui/GuiInventory.java
+++ b/src/main/java/net/minecraft/client/gui/GuiInventory.java
@@ -300,14 +300,6 @@ public class GuiInventory extends GuiContainer
     @Override
 	protected void buttonPressed(GuiButton button)
     {
-        if (button.id == 0)
-        {
-            mc.displayGuiScreen(new GuiAchievements(this, mc.statsCounter));
-        }
-        if (button.id == 1)
-        {
-            mc.displayGuiScreen(new GuiStats(this, mc.statsCounter));
-        }
         if (button == armorButton) {
         	mc.gameSettings.armorProtectionOverlay.toggle();
         }
diff --git a/src/main/java/net/minecraft/client/gui/GuiInventoryCreative.java b/src/main/java/net/minecraft/client/gui/GuiInventoryCreative.java
index cbb72b334..949d03579 100644
--- a/src/main/java/net/minecraft/client/gui/GuiInventoryCreative.java
+++ b/src/main/java/net/minecraft/client/gui/GuiInventoryCreative.java
@@ -27,7 +27,7 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
 	public GuiInventoryCreative(EntityPlayer entityplayer)
 	{
 		super(entityplayer);
-		xSize = 288;
+		xSize = 298;
 		container = (ContainerPlayerCreative)entityplayer.inventorySlots;
 		armourValuesFloat = 186;
 		armourButtonFloatX = 76;
@@ -38,10 +38,10 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
 	public void init()
 	{
 		super.init();
-		controlList.add(lastPageButton = new GuiButton(500, 172, 140, 20, 20, "<"));
-		controlList.add(nextPageButton = new GuiButton(501, 262, 140, 20, 20, ">"));
-		controlList.add(clearSearchButton = new GuiOptionsButton(502, 266, 10, 12, 20, "X"));
-		searchField = new GuiTextField(this, fontRenderer, 173, 7, 96, 18, container.searchText, I18n.getInstance().translateKey("gui.inventory.creative.label.search"));
+		controlList.add(lastPageButton = new GuiButton(500, 0, 0, 20, 20, "<"));
+		controlList.add(nextPageButton = new GuiButton(501, 0, 0, 20, 20, ">"));
+		controlList.add(clearSearchButton = new GuiOptionsButton(0, 0, 10, 12, 20, "X"));
+		searchField = new GuiTextField(this, fontRenderer, 0, 0, 96, 18, container.searchText, I18n.getInstance().translateKey("gui.inventory.creative.label.search"));
 		searchField.drawBackground =false;
 		searchField.setMaxStringLength(14);
 		searchField.setTextChangeListener(this);
@@ -159,7 +159,7 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
 	protected void drawGuiContainerForegroundLayer()
     {
     	super.drawGuiContainerForegroundLayer();
-    	drawStringCenteredNoShadow(fontRenderer, pageString, 228, 146, 0x404040);
+    	drawStringCenteredNoShadow(fontRenderer, pageString, 238, 146, 0x404040);
     }
 	
     @Override
@@ -170,30 +170,30 @@ public class GuiInventoryCreative extends GuiInventory implements ITextChangeLis
         int i = mc.renderEngine.getTexture("/gui/creative.png");
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         mc.renderEngine.bindTexture(i);
-        int j = (width - xSize) / 2;
-        int k = (height - ySize) / 2;
-        lastPageButton.xPosition = j + 172;
-        lastPageButton.yPosition = k + 140;
-        nextPageButton.xPosition = j + 262;
-        nextPageButton.yPosition = k + 140;
-        clearSearchButton.xPosition = j + 270;
-        clearSearchButton.yPosition = k + 6;
-        searchField.xPosition = j + 173;
-        searchField.yPosition = k + 7;
-        drawTexturedModalRect((double)j, (double)k, 0, 0, xSize, ySize, xSize / 2, ySize / 2);
+        int x = (width - xSize) / 2;
+        int y = (height - ySize) / 2;
+        lastPageButton.xPosition = x + 182;
+        lastPageButton.yPosition = y + 140;
+        nextPageButton.xPosition = x + 272;
+        nextPageButton.yPosition = y + 140;
+        clearSearchButton.xPosition = x + 280;
+        clearSearchButton.yPosition = y + 6;
+        searchField.xPosition = x + 183;
+        searchField.yPosition = y + 7;
+        drawTexturedModalRect((double)x, (double)y, 0, 0, xSize, ySize, xSize / 2, ySize / 2);
         GL11.glEnable(32826 /*GL_RESCALE_NORMAL_EXT*/);
         GL11.glEnable(2903 /*GL_COLOR_MATERIAL*/);
         GL11.glEnable(GL11.GL_DEPTH_TEST);
         GL11.glPushMatrix();
-        GL11.glTranslatef(j + 51, k + 75, 50F);
+        GL11.glTranslatef(x + 51, y + 75, 50F);
         float f1 = 30F;
         GL11.glScalef(-f1, f1, f1);
         GL11.glRotatef(180F, 0.0F, 0.0F, 1.0F);
         float f2 = mc.thePlayer.renderYawOffset;
         float f3 = mc.thePlayer.yRot;
         float f4 = mc.thePlayer.xRot;
-        float f5 = (float)(j + 51) - xSize_lo;
-        float f6 = (float)((k + 75) - 50) - ySize_lo;
+        float f5 = (float)(x + 51) - xSize_lo;
+        float f6 = (float)((y + 75) - 50) - ySize_lo;
         GL11.glRotatef(135F, 0.0F, 1.0F, 0.0F);
         Lighting.enableLight();
         GL11.glRotatef(-135F, 0.0F, 1.0F, 0.0F);
diff --git a/src/main/java/net/minecraft/client/gui/createworld/ButtonComponent.java b/src/main/java/net/minecraft/client/gui/createworld/ButtonComponent.java
new file mode 100644
index 000000000..56e9743d3
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/createworld/ButtonComponent.java
@@ -0,0 +1,122 @@
+package net.minecraft.client.gui.createworld;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiTexturedButton;
+import net.minecraft.client.gui.paged.PageComponent;
+import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.sound.SoundCategory;
+import org.lwjgl.opengl.GL11;
+
+import static org.lwjgl.opengl.GL11.*;
+
+public abstract class ButtonComponent
+    implements PageComponent
+{
+    protected static final Minecraft mc = Minecraft.getMinecraft(ButtonComponent.class);
+    protected static final int COMPONENT_SPACING = 2;
+    private static final int BUTTON_WIDTH = 100;
+
+    private final String translationKey;
+
+    protected final GuiButton resetButton;
+
+    public ButtonComponent(String translationKey)
+    {
+        this.translationKey = translationKey;
+        this.resetButton = new GuiTexturedButton(0, "/gui/gui.png", 0, 0, 40, 86, 20, 20);
+    }
+
+    public abstract void resetValue();
+
+    public abstract boolean isDefault();
+
+    @Override
+    public int getHeight()
+    {
+        return COMPONENT_SPACING + 20 + COMPONENT_SPACING;
+    }
+
+    @Override
+    public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY)
+    {
+        FontRenderer fr = mc.fontRenderer;
+        String translated = I18n.getInstance().translateKey(translationKey);
+        int textColor = 0xFFFFFFFF;
+        if (relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= getHeight() - COMPONENT_SPACING) {
+            textColor = 0xFFFFFFA0;
+        }
+        fr.drawStringWithShadow(translated, x, y + (getHeight() / 2) - 4, textColor);
+        resetButton.enabled = !isDefault();
+        renderButton(x, y, width - BUTTON_WIDTH, COMPONENT_SPACING, BUTTON_WIDTH, 20, relativeMouseX, relativeMouseY);
+        int stringWidth = fr.getStringWidth(translated);
+        int lineMaxX = x + width - BUTTON_WIDTH - 8;
+        if (resetButton.enabled) lineMaxX -= 20;
+        drawRect(x + stringWidth + 8, y + getHeight() / 2, lineMaxX, y + getHeight() / 2 + 1, 0x5F7F7F7F);
+    }
+
+    @Override
+    public void onMouseClick(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY)
+    {
+        if (relativeMouseX >= width - BUTTON_WIDTH && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= COMPONENT_SPACING + 20) {
+            mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+            buttonClicked(mouseButton, x, y, width, getHeight(), relativeMouseX - (width - BUTTON_WIDTH), relativeMouseY - COMPONENT_SPACING);
+        } else if (resetButton.enabled && relativeMouseX >= width - BUTTON_WIDTH - 20 && relativeMouseX <= width - BUTTON_WIDTH && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= COMPONENT_SPACING + 20) {
+            mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+            resetValue();
+        }
+    }
+
+    @Override
+    public void onMouseMove(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+        buttonDragged(x, y, width, getHeight(), relativeMouseX - (width - BUTTON_WIDTH), relativeMouseY - COMPONENT_SPACING);
+    }
+
+    @Override
+    public void onMouseRelease(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+        buttonReleased(mouseButton, x, y, width, getHeight(), relativeMouseX - (width - BUTTON_WIDTH), relativeMouseY - COMPONENT_SPACING);
+    }
+
+    protected abstract void buttonClicked(int mouseButton, int x, int y, int width, int height, int relativeMouseX, int relativeMouseY);
+
+    protected void buttonDragged(int x, int y, int width, int height, int relativeMouseX, int relativeMouseY) { }
+
+    protected void buttonReleased(int mouseButton, int x, int y, int width, int height, int relativeMouseX, int relativeMouseY) { }
+
+    @Override
+    public void onKeyPress(int keyCode, char character) { }
+
+    @Override
+    public boolean matchesSearchTerm(String term)
+    {
+        return I18n.getInstance().translateKey(translationKey).toLowerCase().contains(term.toLowerCase());
+    }
+
+    protected void renderButton(int x, int y, int relativeButtonX, int relativeButtonY, int buttonWidth, int buttonHeight, int relativeMouseX, int relativeMouseY) {
+        if (resetButton.enabled) {
+            resetButton.xPosition = x + relativeButtonX - 20;
+            resetButton.yPosition = y + relativeButtonY;
+
+            resetButton.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
+        }
+    }
+
+    protected void drawRect(int minX, int minY, int maxX, int maxY, int argb)
+    {
+        TessellatorStandard tessellator = TessellatorStandard.instance;
+        GL11.glEnable(GL_BLEND);
+        GL11.glDisable(GL_TEXTURE_2D);
+        GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+        tessellator.startDrawingQuads();
+        tessellator.setColorRGBA_I(argb & 0x00FFFFFF, argb >> 24 & 0xff);
+        tessellator.addVertex(minX, maxY, 0.0D);
+        tessellator.addVertex(maxX, maxY, 0.0D);
+        tessellator.addVertex(maxX, minY, 0.0D);
+        tessellator.addVertex(minX, minY, 0.0D);
+        tessellator.draw();
+        GL11.glEnable(GL_TEXTURE_2D);
+        GL11.glDisable(GL_BLEND);
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/createworld/CreateWorldPageRegistry.java b/src/main/java/net/minecraft/client/gui/createworld/CreateWorldPageRegistry.java
new file mode 100644
index 000000000..58ce059ee
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/createworld/CreateWorldPageRegistry.java
@@ -0,0 +1,21 @@
+package net.minecraft.client.gui.createworld;
+
+import net.minecraft.client.gui.paged.Page;
+import net.minecraft.client.gui.paged.PageRegistry;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+
+public class CreateWorldPageRegistry
+    extends PageRegistry {
+    private static final PageRegistry INSTANCE = new PageRegistry();
+
+    public static PageRegistry getInstance() {
+        return INSTANCE;
+    }
+
+    public static final Page GENERAL = INSTANCE.register(new Page("gui.create_world.pages.general.title", new ItemStack(Item.map)))
+        .withComponent(new TextFieldComponent("gui.create_world.pages.general.label.world_name"))
+        .withComponent(new TextFieldComponent("gui.create_world.pages.general.label.world_seed"));
+    public static final Page WORLD_SETTINGS = INSTANCE.register(new Page("gui.create_world.pages.world_settings.title", new ItemStack(Item.dustRedstone)));
+    public static final Page GAME_RULES = INSTANCE.register(new Page("gui.create_world.pages.game_rules.title", new ItemStack(Item.book)));
+}
diff --git a/src/main/java/net/minecraft/client/gui/createworld/GuiCreateWorld.java b/src/main/java/net/minecraft/client/gui/createworld/GuiCreateWorld.java
new file mode 100644
index 000000000..fc852217c
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/createworld/GuiCreateWorld.java
@@ -0,0 +1,20 @@
+package net.minecraft.client.gui.createworld;
+
+import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.paged.GuiPaged;
+
+public class GuiCreateWorld
+    extends GuiPaged {
+    public GuiCreateWorld(GuiScreen parent) {
+        super(
+            parent,
+            CreateWorldPageRegistry.getInstance(),
+            CreateWorldPageRegistry.GENERAL,
+            "gui.create_world.label.title",
+            new String[] {
+                "gui.create_world.button.cancel",
+                "gui.create_world.button.create_world",
+            }
+        );
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/createworld/TextFieldComponent.java b/src/main/java/net/minecraft/client/gui/createworld/TextFieldComponent.java
new file mode 100644
index 000000000..44e9c5f4b
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/createworld/TextFieldComponent.java
@@ -0,0 +1,127 @@
+package net.minecraft.client.gui.createworld;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.GuiTextField;
+import net.minecraft.client.gui.GuiTexturedButton;
+import net.minecraft.client.gui.paged.CallbackComponent;
+import net.minecraft.client.gui.paged.OnValueChangedCallback;
+import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.sound.SoundCategory;
+import org.lwjgl.input.Keyboard;
+import org.lwjgl.opengl.GL11;
+
+import static org.lwjgl.opengl.GL11.*;
+import static org.lwjgl.opengl.GL11.GL_BLEND;
+
+public class TextFieldComponent
+    implements CallbackComponent<String> {
+    protected static final Minecraft mc = Minecraft.getMinecraft(ButtonComponent.class);
+    protected static final int COMPONENT_SPACING = 2;
+    private static final int BUTTON_WIDTH = 150;
+
+    private final String translationKey;
+
+    private final GuiTextField textField;
+
+    private OnValueChangedCallback<String> callback = null;
+
+    public TextFieldComponent(String translationKey)
+    {
+        this.translationKey = translationKey;
+
+        this.textField = new GuiTextField(
+            null,
+            mc.fontRenderer,
+            0, 0,
+            BUTTON_WIDTH,
+            18,
+            "",
+            ""
+        );
+    }
+
+    @Override
+    public int getHeight()
+    {
+        return COMPONENT_SPACING + 20 + COMPONENT_SPACING;
+    }
+
+    @Override
+    public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY)
+    {
+        FontRenderer fr = mc.fontRenderer;
+        String translated = I18n.getInstance().translateKey(translationKey);
+        int textColor = 0xFFFFFFFF;
+        if (relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= getHeight() - COMPONENT_SPACING) {
+            textColor = 0xFFFFFFA0;
+        }
+        fr.drawStringWithShadow(translated, x, y + (getHeight() / 2) - 4, textColor);
+        int stringWidth = fr.getStringWidth(translated);
+        int lineMaxX = x + width - BUTTON_WIDTH - 8;
+        drawRect(x + stringWidth + 8, y + getHeight() / 2, lineMaxX, y + getHeight() / 2 + 1, 0x5F7F7F7F);
+
+        textField.xPosition = x + width - BUTTON_WIDTH;
+        textField.yPosition = y + COMPONENT_SPACING + 1;
+        textField.drawTextBox();
+    }
+
+    @Override
+    public void onMouseClick(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY)
+    {
+        boolean mouseInside = relativeMouseX >= width - BUTTON_WIDTH && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= COMPONENT_SPACING + 20;
+        if (mouseInside) {
+            textField.setFocused(true);
+            Keyboard.enableRepeatEvents(true);
+        } else {
+            textField.setFocused(false);
+            Keyboard.enableRepeatEvents(false);
+        }
+    }
+
+    @Override
+    public void onMouseMove(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+    }
+
+    @Override
+    public void onMouseRelease(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+    }
+
+    @Override
+    public void onKeyPress(int keyCode, char character) {
+        if (textField.isFocused) {
+            textField.textboxKeyTyped(character, keyCode);
+        }
+    }
+
+    @Override
+    public boolean matchesSearchTerm(String term)
+    {
+        return I18n.getInstance().translateKey(translationKey).toLowerCase().contains(term.toLowerCase());
+    }
+
+    protected void drawRect(int minX, int minY, int maxX, int maxY, int argb)
+    {
+        TessellatorStandard tessellator = TessellatorStandard.instance;
+        GL11.glEnable(GL_BLEND);
+        GL11.glDisable(GL_TEXTURE_2D);
+        GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+        tessellator.startDrawingQuads();
+        tessellator.setColorRGBA_I(argb & 0x00FFFFFF, argb >> 24 & 0xff);
+        tessellator.addVertex(minX, maxY, 0.0D);
+        tessellator.addVertex(maxX, maxY, 0.0D);
+        tessellator.addVertex(maxX, minY, 0.0D);
+        tessellator.addVertex(minX, minY, 0.0D);
+        tessellator.draw();
+        GL11.glEnable(GL_TEXTURE_2D);
+        GL11.glDisable(GL_BLEND);
+    }
+
+    @Override
+    public CallbackComponent<String> withOnValueChangedCallback(OnValueChangedCallback<String> callback) {
+        this.callback = callback;
+        return this;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/createworld/WorldConfig.java b/src/main/java/net/minecraft/client/gui/createworld/WorldConfig.java
new file mode 100644
index 000000000..79816a569
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/createworld/WorldConfig.java
@@ -0,0 +1,70 @@
+package net.minecraft.client.gui.createworld;
+
+import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.util.helper.MathHelper;
+
+import java.util.Random;
+
+public class WorldConfig {
+    private String name;
+    private long seed;
+    private Gamemode gamemode;
+    private boolean cheatsEnabled;
+
+    public WorldConfig(String name) {
+        this.name = name;
+        this.seed = (new Random()).nextLong();
+        this.gamemode = Gamemode.survival;
+        this.cheatsEnabled = false;
+    }
+
+    public String getName() {
+        return name;
+    }
+
+    public void setName(String name) {
+        this.name = name;
+    }
+
+    public long getSeed() {
+        return seed;
+    }
+
+    public void setSeed(long seed) {
+        this.seed = seed;
+    }
+
+    public void setSeed(String seed) {
+        if(!MathHelper.stringNullOrLengthZero(seed))
+        {
+            try
+            {
+                long parsedSeed = Long.parseLong(seed);
+                if(parsedSeed != 0L)
+                {
+                    this.seed = parsedSeed;
+                }
+            }
+            catch(NumberFormatException e)
+            {
+                this.seed = seed.hashCode();
+            }
+        }
+    }
+
+    public Gamemode getGamemode() {
+        return gamemode;
+    }
+
+    public void setGamemode(Gamemode gamemode) {
+        this.gamemode = gamemode;
+    }
+
+    public boolean isCheatsEnabled() {
+        return cheatsEnabled;
+    }
+
+    public void setCheatsEnabled(boolean cheatsEnabled) {
+        this.cheatsEnabled = cheatsEnabled;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/paged/CallbackComponent.java b/src/main/java/net/minecraft/client/gui/paged/CallbackComponent.java
new file mode 100644
index 000000000..db856a25b
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/paged/CallbackComponent.java
@@ -0,0 +1,6 @@
+package net.minecraft.client.gui.paged;
+
+public interface CallbackComponent<T>
+    extends PageComponent {
+    CallbackComponent<T> withOnValueChangedCallback(OnValueChangedCallback<T> callback);
+}
